net.sf.saxon.tree.util

## Class Orphan

- java.lang.Object
- - net.sf.saxon.tree.util.Orphan

- All Implemented Interfaces:
    Source, PullEvent, Item, MutableNodeInfo, NodeInfo, Sequence

      public final class Orphan
      extends Object
      implements MutableNodeInfo

  A node (implementing the NodeInfo interface) representing an attribute, text node, comment, processing instruction, or namespace that has no parent (and of course no children). Exceptionally it is also used (during whitespace stripping) to represent a standalone element.

  In general this class does not impose constraints defined in the data model: that is the responsibility of the client. For example, the class does not prevent you from creating a comment or text node that has a name or a non-trivial type annotation.

  Author:
    Michael H. Kay

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Orphan(Configuration config)` Create an Orphan node

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAttribute(NodeName nameCode, SimpleType attType, CharSequence value, int properties)` Add an attribute to this element node.
    `void` | `addNamespace(NamespaceBinding nscode, boolean inherit)` Add a namespace binding (that is, a namespace node) to this element.
    `AtomicSequence` | `atomize()` Get the typed value.
    `int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
    `int` | `comparePosition(NodeInfo other)` Determine the relative position of this node and another node, in document order, distinguishing whether the first node is a preceding, following, descendant, ancestor, or the same node as the second.
    `void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (deep copy)
    `void` | `delete()` Delete this node (that is, detach it from its parent).
    `boolean` | `equals(Object other)` The equals() method compares nodes for identity.
    `void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node.
    `String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
    `String` | `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `int` | `getColumnNumber()` Get column number
    `Configuration` | `getConfiguration()` Get the configuration
    `NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
    `String` | `getDisplayName()` Get the display name of this node.
    `long` | `getDocumentNumber()` Get the document number of the document containing this node.
    `DocumentInfo` | `getDocumentRoot()` Get the root (document) node
    `int` | `getFingerprint()` Get fingerprint.
    `int` | `getLineNumber()` Get line number
    `String` | `getLocalPart()` Get the local part of the name of this node.
    `int` | `getNameCode()` Get name code.
    `NamePool` | `getNamePool()` Get the name pool
    `int` | `getNodeKind()` Return the kind of node.
    `NodeInfo` | `getParent()` Get the NodeInfo object representing the parent of this node
    `String` | `getPrefix()` Get the prefix of the name of the node.
    `NodeInfo` | `getRoot()` Get the root node of this tree (not necessarily a document node).
    `SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
    `String` | `getStringValue()` Return the string value of the node.
    `CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
    `String` | `getSystemId()` Get the System ID for the node.
    `int` | `getTypeAnnotation()` Get the type annotation
    `String` | `getURI()` Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` Determine whether the node has any children.
    `int` | `hashCode()` The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `Item` | `head()` To implement `Sequence`, this method returns the item itself
    `void` | `insertChildren(NodeInfo[] source, boolean atStart, boolean inherit)` Insert copies of a sequence of nodes as children of this node.
    `void` | `insertSiblings(NodeInfo[] source, boolean before, boolean inherit)` Insert copies of a sequence of nodes as siblings of this node.
    `boolean` | `isDeleted()` Test whether this MutableNodeInfo object represents a node that has been deleted.
    `boolean` | `isId()` Determine whether this node has the is-id property
    `boolean` | `isIdref()` Determine whether this node has the is-idref property
    `boolean` | `isNilled()` Determine whether the node has the is-nilled property
    `boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
    `SequenceIterator` | `iterate()` To implement `Sequence`, this method returns a singleton iterator that delivers this item in the form of a sequence
    `AxisIterator` | `iterateAxis(byte axisNumber)` Return an iteration over the nodes reached by the given axis from this node
    `AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iteration over the nodes reached by the given axis from this node
    `Builder` | `newBuilder()` Get a Builder suitable for building nodes that can be attached to this document.
    `void` | `removeAttribute(NodeInfo attribute)` Remove an attribute from this element node
    `void` | `removeTypeAnnotation()` Remove type information from this node (and its ancestors, recursively).
    `void` | `rename(NodeName newNameCode)` Rename this node.
    `void` | `replace(NodeInfo[] replacement, boolean inherit)` Replace this node with a given sequence of nodes
    `void` | `replaceStringValue(CharSequence stringValue)` Replace the string-value of this node.
    `void` | `setIsId(boolean id)` Set the isId property
    `void` | `setIsIdref(boolean idref)` Set the isIdref property
    `void` | `setNodeKind(short kind)` Set the node kind
    `void` | `setNodeName(NodeName nodeName)` Set the name of the node
    `void` | `setStringValue(CharSequence stringValue)` Set the string value of the node
    `void` | `setSystemId(String systemId)` Set the base URI of the node
    `void` | `setTypeAnnotation(int typeAnnotation)` Set the type annotation of the node
    `void` | `setTypeAnnotation(SchemaType typeAnnotation)` Set the type annotation of the node

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Orphan

          public Orphan(Configuration config)

      Create an Orphan node
      Parameters:
        `config` - the Saxon configuration

  - ### Method Detail

    - #### head

          public Item head()

      To implement `Sequence`, this method returns the item itself
      Specified by:
        `head` in interface `Sequence`
      Returns:
        this item

    - #### iterate

          public SequenceIterator iterate()

      To implement `Sequence`, this method returns a singleton iterator that delivers this item in the form of a sequence
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        a singleton iterator that returns this item

    - #### setNodeKind

          public void setNodeKind(short kind)

      Set the node kind
      Parameters:
        `kind` - the kind of node, for example `Type.ELEMENT` or `Type.ATTRIBUTE`

    - #### setNodeName

          public void setNodeName(NodeName nodeName)

      Set the name of the node
      Parameters:
        `nodeName` - the name of the node. May be null for unnamed nodes such as text and comment nodes

    - #### setStringValue

          public void setStringValue(CharSequence stringValue)

      Set the string value of the node
      Parameters:
        `stringValue` - the string value of the node

    - #### setTypeAnnotation

          public void setTypeAnnotation(SchemaType typeAnnotation)

      Set the type annotation of the node
      Parameters:
        `typeAnnotation` - the type annotation

    - #### setTypeAnnotation

          public void setTypeAnnotation(int typeAnnotation)

      Set the type annotation of the node
      Specified by:
        `setTypeAnnotation` in interface `MutableNodeInfo`
      Parameters:
        `typeAnnotation` - the type annotation

    - #### setSystemId

          public void setSystemId(String systemId)

      Set the base URI of the node
      Specified by:
        `setSystemId` in interface `Source`
      Parameters:
        `systemId` - the base URI of the node

    - #### setIsId

          public void setIsId(boolean id)

      Set the isId property
      Parameters:
        `id` - the isId property

    - #### setIsIdref

          public void setIsIdref(boolean idref)

      Set the isIdref property
      Parameters:
        `idref` - the isIdref property

    - #### getNodeKind

          public int getNodeKind()

      Return the kind of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Type.ELEMENT, Type.TEXT, Type.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value. The result of this method will always be consistent with the method `net.sf.saxon.om.Item#getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Returns:
        the Saxon configuration object

    - #### getNamePool

          public NamePool getNamePool()

      Get the name pool
      Specified by:
        `getNamePool` in interface `NodeInfo`
      Returns:
        the namepool

    - #### getTypeAnnotation

          public int getTypeAnnotation()

      Get the type annotation
      Specified by:
        `getTypeAnnotation` in interface `NodeInfo`
      Returns:
        the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

        For elements and attributes, this is the type annotation as defined in XDM. For document nodes, it should be one of XS_UNTYPED if the document has not been validated, or XS_ANY_TYPE if validation has taken place (that is, if any node in the document has an annotation other than Untyped or UntypedAtomic).

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### isSameNodeInfo

          public boolean isSameNodeInfo(NodeInfo other)

      Determine whether this is the same node as another node.
      Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `isSameNodeInfo` in interface `NodeInfo`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this Node object and the supplied Node object represent the same node in the tree.

    - #### equals

          public boolean equals(Object other)

      The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
      Since:
        8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          public String getSystemId()

      Get the System ID for the node.
      Specified by:
        `getSystemId` in interface `Source`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

    - #### getBaseURI

          public String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### getLineNumber

          public int getLineNumber()

      Get line number
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Returns:
        the line number of the node in its original source document; or -1 if not available

    - #### getColumnNumber

          public int getColumnNumber()

      Get column number
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### compareOrder

          public int compareOrder(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### comparePosition

          public int comparePosition(NodeInfo other)

      Determine the relative position of this node and another node, in document order, distinguishing whether the first node is a preceding, following, descendant, ancestor, or the same node as the second.

      The other node must always be in the same tree; the effect of calling this method when the two nodes are in different trees is undefined. If either node is a namespace or attribute node, the method should throw UnsupportedOperationException.
      Specified by:
        `comparePosition` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        `AxisInfo.PRECEDING` if this node is on the preceding axis of the other node; `AxisInfo.FOLLOWING` if it is on the following axis; `AxisInfo.ANCESTOR` if the first node is an ancestor of the second; `AxisInfo.DESCENDANT` if the first is a descendant of the second; `AxisInfo.SELF` if they are the same node.
      Throws:
        `UnsupportedOperationException` - if either node is an attribute or namespace
      Since:
        9.5

    - #### getStringValue

          public String getStringValue()

      Return the string value of the node.
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Returns:
        the string value of the node
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getNameCode

          public int getNameCode()

      Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.
      Specified by:
        `getNameCode` in interface `NodeInfo`
      Returns:
        an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      See Also:
        `allocate`

    - #### getFingerprint

          public int getFingerprint()

      Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

    - #### getLocalPart

          public String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getURI

          public String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, return null. For a node with an empty prefix, return an empty string.

    - #### getPrefix

          public String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getDisplayName

          public String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        null - an Orphan has no parent.

    - #### iterateAxis

          public AxisIterator iterateAxis(byte axisNumber)

      Return an iteration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be searched, e.g. Axis.CHILD or Axis.ANCESTOR
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### iterateAxis

          public AxisIterator iterateAxis(byte axisNumber,
                                 NodeTest nodeTest)

      Return an iteration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be searched, e.g. Axis.CHILD or Axis.ANCESTOR
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          public String getAttributeValue(String uri,
                                 String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of this tree (not necessarily a document node). Always returns this node in the case of an Orphan node.
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node. If this node has no parent, then the method returns this node.

    - #### getDocumentRoot

          public DocumentInfo getDocumentRoot()

      Get the root (document) node
      Specified by:
        `getDocumentRoot` in interface `NodeInfo`
      Returns:
        the DocumentInfo representing the containing document, or null if the node is not part of a document. Always null for an Orphan node.

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        false - an orphan node never has any children

    - #### generateId

          public void generateId(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer, into which will be placed a string that uniquely identifies this node, within this document. The calling code prepends information to make the result unique across all documents.

    - #### getDocumentNumber

          public long getDocumentNumber()

      Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.
      Specified by:
        `getDocumentNumber` in interface `NodeInfo`
      Returns:
        the document number of the document containing this node

    - #### copy

          public void copy(Receiver out,
                  int copyOptions,
                  int locationId)
                    throws XPathException

      Copy this node to a given outputter (deep copy)
      Specified by:
        `copy` in interface `NodeInfo`
      Parameters:
        `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
        `copyOptions` - a selection of the options defined in `CopyOptions`
        `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
      Throws:
        `XPathException` - if any downstream error occurs

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

    - #### isNilled

          public boolean isNilled()

      Determine whether the node has the is-nilled property
      Specified by:
        `isNilled` in interface `NodeInfo`
      Returns:
        true if the node has the is-nilled property

    - #### insertChildren

          public void insertChildren(NodeInfo[] source,
                            boolean atStart,
                            boolean inherit)

      Insert copies of a sequence of nodes as children of this node.

      This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes will be copied to form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed.

      Specified by:
        `insertChildren` in interface `MutableNodeInfo`
      Parameters:
        `source` - the nodes to be inserted
        `atStart` - true if the new nodes are to be inserted before existing children; false if they are
        `inherit` - true if the insert nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared

    - #### insertSiblings

          public void insertSiblings(NodeInfo[] source,
                            boolean before,
                            boolean inherit)

      Insert copies of a sequence of nodes as siblings of this node.

      This method takes no action unless the target node is an element, text node, comment, or processing instruction, and one that has a parent node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes must use the same data model implementation as the tree into which they will be inserted.

      Specified by:
        `insertSiblings` in interface `MutableNodeInfo`
      Parameters:
        `source` - the nodes to be inserted
        `before` - true if the new nodes are to be inserted before the target node; false if they are
        `inherit` - true if the insert nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared

    - #### removeAttribute

          public void removeAttribute(NodeInfo attribute)

      Remove an attribute from this element node

      If this node is not an element, or if it has no attribute with the specified name, this method takes no action.

      The attribute node itself is not modified in any way.

      Specified by:
        `removeAttribute` in interface `MutableNodeInfo`
      Parameters:
        `attribute` - the attribute node to be removed

    - #### addAttribute

          public void addAttribute(NodeName nameCode,
                          SimpleType attType,
                          CharSequence value,
                          int properties)

      Add an attribute to this element node.

      If this node is not an element, or if the supplied node is not an attribute, the method takes no action. If the element already has an attribute with this name, the existing attribute is replaced.

      Specified by:
        `addAttribute` in interface `MutableNodeInfo`
      Parameters:
        `nameCode` - the name of the new attribute
        `attType` - the type annotation of the new attribute
        `value` - the string value of the new attribute
        `properties` - properties including IS_ID and IS_IDREF properties

    - #### delete

          public void delete()

      Delete this node (that is, detach it from its parent).

      If this node has preceding and following siblings that are both text nodes, the two text nodes will be joined into a single text node (the identity of this node with respect to its predecessors is undefined).

      Specified by:
        `delete` in interface `MutableNodeInfo`

    - #### isDeleted

          public boolean isDeleted()

      Test whether this MutableNodeInfo object represents a node that has been deleted. Generally, such a node is unusable, and any attempt to use it will result in an exception being thrown
      Specified by:
        `isDeleted` in interface `MutableNodeInfo`
      Returns:
        true if this node has been deleted

    - #### replace

          public void replace(NodeInfo[] replacement,
                     boolean inherit)

      Replace this node with a given sequence of nodes
      Specified by:
        `replace` in interface `MutableNodeInfo`
      Parameters:
        `replacement` - the replacement nodes
        `inherit` - true if the replacement nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
      Throws:
        `IllegalArgumentException` - if any of the replacement nodes is of the wrong kind. When replacing a child node, the replacement nodes must all be elements, text, comment, or PI nodes; when replacing an attribute, the replacement nodes must all be attributes.
        `IllegalStateException` - if this node is deleted or if it has no parent node.

    - #### replaceStringValue

          public void replaceStringValue(CharSequence stringValue)

      Replace the string-value of this node. If applied to an element or document node, this causes all existing children to be deleted, and replaced with a new text node whose string value is the value supplied. The caller is responsible for checking that the value is valid, for example that comments do not contain a double hyphen; the implementation is not required to check for such conditions.
      Specified by:
        `replaceStringValue` in interface `MutableNodeInfo`
      Parameters:
        `stringValue` - the new string value

    - #### rename

          public void rename(NodeName newNameCode)

      Rename this node.

      This call has no effect if applied to a nameless node, such as a text node or comment.

      If necessary, a new namespace binding will be added to the target element, or to the element parent of the target attribute

      Specified by:
        `rename` in interface `MutableNodeInfo`
      Parameters:
        `newNameCode` - the namecode of the new name in the name pool
      Throws:
        `IllegalArgumentException` - if the new name code is not present in the name pool, or if it has a (prefix, uri) pair in which the prefix is the same as that of an existing in-scope namespace binding and the uri is different from that namespace binding.

    - #### addNamespace

          public void addNamespace(NamespaceBinding nscode,
                          boolean inherit)

      Add a namespace binding (that is, a namespace node) to this element. This call has no effect if applied to a node other than an element.
      Specified by:
        `addNamespace` in interface `MutableNodeInfo`
      Parameters:
        `nscode` - The namespace code representing the (prefix, uri) pair of the namespace binding to be added. If the target element already has a namespace binding with this (prefix, uri) pair, the call has no effect. If the target element currently has a namespace binding with this prefix and a different URI, an exception is raised.
        `inherit` - If true, the new namespace binding will be inherited by any children of the target element that do not already have a namespace binding for the specified prefix, recursively. If false, the new namespace binding will not be inherited.
      Throws:
        `IllegalArgumentException` - if the namespace code is not present in the namepool, or if the target element already has a namespace binding for this prefix

    - #### removeTypeAnnotation

          public void removeTypeAnnotation()

      Remove type information from this node (and its ancestors, recursively). This method implements the upd:removeType() primitive defined in the XQuery Update specification. (Note: the caller is responsible for updating the set of nodes marked for revalidation)
      Specified by:
        `removeTypeAnnotation` in interface `MutableNodeInfo`

    - #### newBuilder

          public Builder newBuilder()

      Get a Builder suitable for building nodes that can be attached to this document. This implementation always throws an exception: the method should only be called on a document or element node when creating new children.
      Specified by:
        `newBuilder` in interface `MutableNodeInfo`
      Returns:
        a new Builder that constructs nodes using the same object model implementation as this one, suitable for attachment to this tree

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.